Bug 439263 - Review Request: javahelp2 - needed for NetBeans Platform
Review Request: javahelp2 - needed for NetBeans Platform
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Colin Walters
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 439265 456341
  Show dependency treegraph
 
Reported: 2008-03-27 15:01 EDT by Jaroslav Tulach
Modified: 2008-11-16 08:33 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-06-26 11:37:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
walters: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
Commited, what next? (3.72 KB, text/plain)
2008-06-09 04:37 EDT, Jaroslav Tulach
no flags Details

  None (edit)
Description Jaroslav Tulach 2008-03-27 15:01:22 EDT
Spec URL: http://www.xelfi.cz/download/dev/SRPMS/javahelp2.spec
SRPM URL: http://www.xelfi.cz/download/dev/SRPMS/javahelp2-2.0.05-2.rpm
Description: 

JavaHelp software is a full-featured, platform-independent, extensible
help system that enables developers and authors to incorporate online
help in applets, components, applications, operating systems, and
devices. Authors can also use the JavaHelp software to deliver online
documentation for the Web and corporate Intranet.
Comment 1 Colin Walters 2008-03-31 23:59:50 EDT
In a quick glance:

* %mkrel problem
* BuildRoot needs to have release at least, see
http://fedoraproject.org/wiki/Packaging/Guidelines#head-b4fdd45fa76cbf54c885ef0836361319ab962473
* I don't understand the purpose of the javadoc %pre and %post
* Is there a reason the two shell scripts can't be included upstream?  (not a
requirement, just asking)


Comment 3 Jason Tibbitts 2008-04-05 01:17:49 EDT
A few comments as I come up to speed with reviewing Java packages using our
fancy new guidelines:

This builds and installs OK.  rpmlint says:

  javahelp2.src: W: mixed-use-of-spaces-and-tabs (spaces: line 9, tab: line 31)
Not a big deal; fix it if you like.

  javahelp2.src: W: non-standard-group Development/Java
This is fine; we don't really care about Group.

  javahelp2.src: E: no-changelogname-tag
There is no changelog section at all.  One is required, and the entries need to
be in one of the formats from
http://fedoraproject.org/wiki/Packaging/Guidelines#Changelogs

  javahelp2.src: W: strange-permission javahelp2-jhindexer.sh 0755
  javahelp2.src: W: strange-permission javahelp2-jhsearch.sh 0755
This isn't a real problem; usually you don't depend on permissions on files
extracted from the srpm but as long as they aren't mode 666 or something it's
not an issue.

It would be nice for you to answer Colin's question from comment 1.

The summary, well, isn't really a summary.  Can you come up with a 70-character
summary of this package?

According to the guidelines, you need an epoch on your java-devel requirement:
  BuildRequires:  java-devel >= 1:1.6.0

The main package needs a dependency on java and the javadoc package needs at
least a dependency on jpackage-utils (so that /usr/share/javadoc is owned properly).

There seems to be some sort of test suite in jhMaster/JavaHelp/test.  I do not
know if it is something that is runnable at build time, but if it is then you
need to add a %check section.

* source files match upstream:
   338b3888bd3b058a6d9c65ad5fe15d4effbe6c13a15d6da1c5390a06f0b69757  
   javahelp2-src-2.0.05.zip
* package meets naming and versioning guidelines.
* specfile is properly named, is cleanly written and uses macros consistently.
X No changelog section.
X summary isn't really a summary.
* description is OK.
* dist tag is present.
* build root is OK.
* license field matches the actual license.
* license is open source-compatible.
* license text not included upstream.
* latest version is being packaged.
X BuildRequires not quite right.
* %clean is present.
* package builds in mock (rawhide, x86_64).
* package installs properly.
X rpmlint has a valid complaint.
X final provides and requires are not quite right:
  javahelp2-2.0.05-3.fc9.noarch.rpm
   javahelp2 = 0:2.0.05-3.fc9
  =
   /bin/sh
   jpackage-utils >= 0:1.5.32
X  (no dependency on java)

  javahelp2-javadoc-2.0.05-3.fc9.noarch.rpm
   javahelp2-javadoc = 0:2.0.05-3.fc9
  =
X  (no dependency on jpackage-utils)

? %check is not present, but there seems to be a test suite.  Can it be run at 
  build time?
* owns the directories it creates.
* doesn't own any directories it shouldn't.
* no duplicates in %files.
* file permissions are appropriate.
* no scriptlets present.
* code, not content.
* %docs are not necessary for the proper functioning of the package.

Java-specific bits:
* no pre-built jars
* single jar, named after the package
* jarfiles are under _javadir.
* javadocs are under _javadocdir.
Comment 4 Jaroslav Tulach 2008-04-05 10:02:34 EDT
Use "full-featured, platform-independent, extensible help system", I do not 
care.

Log is missing, because mandriva generates the log file automatically from svn 
logs. Just think something up, it is first fedora release anyway.

We do not really control upstream project, that is why I prefer not to add 
anything there.

I know nothing about the test suite. I never tried to run it. My expectation 
is that it will miss some fancy test harness from Sun.

All that you want to change is OK from my point of view. I just want the 
library to be package. I do not care much how. Thanks a lot for your help.
Comment 5 Jason Tibbitts 2008-04-05 15:43:13 EDT
I think there must be some confusion here.

If this package is approved, you will the maintainer of the package in Fedora. 
Therefore it is up to you to care about things like the summary and the
changelog.  What Mandriva does is of absolutely no consequence here; you must
provide a package which is acceptable to Fedora.  You shouldn't tell me to add
something, because my function is to check the package for acceptability, not to
apply any fixes to it.

I understand that you want the library to be packaged, but your role in the
process is far more than just dropping the package in a bugzilla ticket and
being done with it.  You must maintain it in Fedora.  You must respond to
bugzilla tickets filed against it and such, issue builds and update notices,
etc.  You should know about the test suite, or find out about it, because that
is your function as the maintainer of the package.

Also, I have a feeling from your responses that this is your first package
submission, and if that's the case then you will need a sponsor.  Honestly I'm
going to need to see from you a much greater understanding of how things work in
Fedora before I personally would be willing to sponsor you.

Thus I'm going to unassign myself from this ticket, and refer you to some
documents in our wiki:

http://fedoraproject.org/wiki/PackageMaintainers
http://fedoraproject.org/wiki/PackageMaintainers/Join
http://fedoraproject.org/wiki/PackageMaintainers/HowToGetSponsored
Comment 6 Jaroslav Tulach 2008-04-06 02:46:42 EDT
Jason, for some reason you became upset. Sorry for you. Looks like it is my 
fault, so I apologize for wasting your time. 
Comment 7 Colin Walters 2008-04-28 12:20:48 EDT
Jaroslav, do you think you could add an initial %changelog and tweak the
dependencies?  As an aside I'd like to see Fedora do the %changelog generation
too, nice to hear Mandriva does it, but for now we require %changelog.
Comment 8 Jaroslav Tulach 2008-04-30 08:31:17 EDT
Thanks for helping me Colin. Here is SRPM updated with changelog:
http://www.xelfi.cz/download/dev/SRPMS/javahelp2-2.0.05-4.src.rpm
I hope there are no other blocking issues.
Comment 9 Andrew Overholt 2008-04-30 11:04:21 EDT
Jaroslav:  can you post a new .spec as well?

Looking at the .spec from that SRPM, I still see a few issues (in addition to
the other concerns above):

- remove the Epoch entirely
- write a summary
- it seems odd that jhall.jar is being installed as javahelp-%{version}.jar
- add java as a Requires
- add a version into the most recent changelog entry
Comment 10 Jaroslav Tulach 2008-04-30 11:14:32 EDT
I've updated the version at
http://www.xelfi.cz/download/dev/SRPMS/javahelp2-2.0.05-4.src.rpm
to fix everything except the jhall.jar issue. Imho, it is better to have 
javahelp-%{version}.jar as jhall is some relict from past when people believe 
that javahelp shall have two parts. Now it is one package anyway, so it does 
not make sense to produce more than one JAR and call it as jhclient, jhall, 
etc.
Comment 11 Andrew Overholt 2008-04-30 11:26:20 EDT
Okay, thanks for the thoughts about jhall.jar.  I agree.

Can you post a .spec URL as well, please?  Also, it's typical that one bumps the
release in the specfile for each change they make -- like bumping it to -5 and
adding a changelog comment like "Removed epoch and did other stuff as per Fedora
review".
Comment 13 Colin Walters 2008-04-30 11:49:03 EDT
A small rpmlint issue:
javahelp2.noarch: W: no-documentation

But looking at the upstream sources, I don't see anything like a README,
COPYING, LICENSE etc. file that is suitable.  So we can skip this; though if you
have any contact with upstream it'd be a good idea to ask them to ship at least
a COPYING/LICENSE file.

It looks like we now have things from Jason's review fixed like the build dep
epoch, as well as things Andrew noticed.

Jason also asked about a test suite, but taking a quick look at those files,
they are not automated tests, but quick-launch interactive programs for developers.

I don't see any other issues with this package, marking as reviewed.
Comment 14 Andrew Overholt 2008-04-30 11:55:16 EDT
Jaroslav:  now that Colin's given the go-ahead, I think you're at this stage of
 "becoming a Fedora contributor":

http://fedoraproject.org/wiki/PackageMaintainers/Join#head-a601c13b0950a89568deafa65f505b4b58ee869b
Comment 15 Jaroslav Tulach 2008-05-08 11:23:14 EDT
Hi. I have fedora-cvs on my computer. What now?
Comment 16 Thomas Fitzsimmons 2008-05-08 13:20:27 EDT
(In reply to comment #15)
> Hi. I have fedora-cvs on my computer. What now?

Did you follow the "Import Your Package" step yet?

http://fedoraproject.org/wiki/PackageMaintainers/Join#head-3de96e1e7f6c4c9197e8beb02a0b3d7a5eb9dada

Then you just check it out, cd to the devel branch, make tag and make build.
Comment 17 Kevin Fenzi 2008-05-08 13:38:06 EDT
You seem to be at the step right before that. 
Please read: 
http://fedoraproject.org/wiki/PackageMaintainers/CVSAdminProcedure

You have set the fedora-cvs flag to ?, but haven't added a template from that
page on what your cvs request is. :) 
Comment 18 Jaroslav Tulach 2008-05-08 13:47:37 EDT
New Package CVS Request
=======================
Package Name: javahelp2
Short Description: JavaHelp is a full-featured, platform-independent, 
extensible help system
Owners: jtulach
Branches: F-9
InitialCC:  fitzsim
Cvsextras Commits: yes
Comment 19 Kevin Fenzi 2008-05-08 15:43:09 EDT
Thanks. cvs done. 

I shortened the Description to just "a full-featured, platform-independent,
extensible help system" Since the name is already in the package name, no need
to duplicate it. 


Comment 20 Thomas Fitzsimmons 2008-05-28 19:43:59 EDT
Jaroslav do you plan to build javahelp2 into koji soon?
Comment 21 Jaroslav Tulach 2008-06-03 07:48:55 EDT
Resend5: Cannot proceed with JavaHelp
 Od:Jaroslav Tulach
 Komu: fedora-devel-java-list <fedora-devel-java-list@redhat.com>
 Kopie: Andrew Overholt <overholt@redhat.com>, Dalibor Topic 
<Dalibor.Topic@sun.com>
 
Dne Saturday 24 May 2008 07:24:20 Jaroslav Tulach napsal(a):
> Dne Monday 19 May 2008 20:02:20 Jaroslav Tulach napsal(a):
> > Dne Monday 12 May 2008 20:48:07 Jaroslav Tulach napsal(a):
> > > Hello guys,
> > > I need help with fedora-cvs, it yields:
> > >
> > > Error: Permission denied (publickey,keyboard-interactive).
> > > cvs [checkout aborted]: end of file from server (consult above messages
> > > if any)
> > >
> > > I guess that will be because missing .ssh directory, but when following
> > > the page
> > > http://fedoraproject.org/wiki/PackageMaintainers/Join
> > > there was no instruction to create .ssh/id_dsa! Or is it there and I am
> > > just too blind to find it?
> >
> > Please advice.
> > -jst
Comment 22 Andrew Overholt 2008-06-03 09:48:28 EDT
Jaroslav:  perhaps you missed it, but David told you what to do in an email:

https://www.redhat.com/archives/fedora-devel-java-list/2008-May/msg00026.html
Comment 23 Jaroslav Tulach 2008-06-06 01:37:55 EDT
Yes, I have missed that advice. Thanks, but it is not enough, key is uploaded 
and still:

~/src$ fedora-cvs javahelp2
Checking out javahelp2 from fedora cvs:
Error: Permission denied (publickey,keyboard-interactive).
cvs [checkout aborted]: end of file from server (consult above messages if 
any)
$ ll ~/.ssh/
total 24
-r-------- 1 jarda jarda 1675 2008-05-03 11:46 id_rsa
-rw-r--r-- 1 jarda jarda  409 2008-05-03 11:46 id_rsa.pub
-rw-r--r-- 1 jarda jarda  246 2008-05-03 10:30 known_hosts
Comment 24 Andrew Overholt 2008-06-06 08:22:25 EDT
ssh -v to your fedorapeople account and paste the output here
Comment 25 Jaroslav Tulach 2008-06-09 04:08:17 EDT
I've connected to fedorepeople and I've also just got the CVS. Looks like 
there was some delay between getting the key and being able to use it. Now I 
think I will proceed with the upload.
Comment 26 Jaroslav Tulach 2008-06-09 04:37:52 EDT
Created attachment 308671 [details]
Commited, what next?
Comment 27 Kevin Fenzi 2008-06-09 12:22:24 EDT
Jaroslav: Looks like you are at this step: 
http://fedoraproject.org/wiki/PackageMaintainers/Join#Request_Builds

I am going to clear the cvs flag here as CVS is done. 
Comment 28 Thomas Fitzsimmons 2008-06-26 11:37:32 EDT
I built this into Rawhide.  Let's target Fedora 10 for NetBeans.

Note You need to log in before you can comment on or make changes to this bug.